﻿using AAD_KeyVault_Certificate_Authentication.Abstractions;
using Microsoft.Extensions.Configuration;
using System;

namespace AAD_KeyVault_Certificate_Authentication.ConfigurationSettings
{
    public sealed class ConfigurationGraph : IConfigurationGraph
    {
        public Guid ClientId { get; }
        public Guid TenantId { get; }
        public string KeyVaultUri { get; }
        public string CertificateName { get; }
        public bool UseAzureCliCredentials { get; }
        public ConfigurationGraph(IConfiguration configuration)
        {
            ClientId = Guid.Parse(configuration["Graph:ClientId"]);
            TenantId = Guid.Parse(configuration["Graph:TenantId"]);
            KeyVaultUri = configuration["Graph:KeyVaultUri"] ?? throw new Exception("Could not find configuration Graph:KeyVaultUri");
            CertificateName = configuration["Graph:CertificateName"] ?? throw new Exception("Could not find configuration Graph:CertificateName");
            UseAzureCliCredentials = configuration.GetValue<bool?>("Graph:UseAzureCliCredentials") ?? false;
        }
    }
}
