﻿using System.Collections.Generic;
using System.Threading;

namespace AAD_KeyVault_Certificate_Authentication.Abstractions
{
    public class BatchAsyncEnumerable<TEntity> : IAsyncEnumerable<TEntity>
    {
        private readonly IBatchGraphProvider<TEntity> _batchGraphProvider;

        public BatchAsyncEnumerable(IBatchGraphProvider<TEntity> batchGraphProvider)
        {
            _batchGraphProvider = batchGraphProvider;
        }

        public IAsyncEnumerator<TEntity> GetAsyncEnumerator(CancellationToken cancellationToken = default)
        {
            return new BatchAsyncEnumerator<TEntity>(_batchGraphProvider);
        }
    }

}
