﻿using Microsoft.Graph;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace AAD_KeyVault_Certificate_Authentication.Abstractions
{
    public interface IGraphClient
    {
        IAsyncEnumerable<Group> EnumerateGroupsAsync();

        /// <summary>
        /// https://docs.microsoft.com/en-us/graph/api/user-list?view=graph-rest-1.0&tabs=http
        /// GET /users?$select=displayName,mail,userPrincipalName,onPremisesExtensionAttributes&$top=1&skip=2
        /// Note: Skip does not work. Therefore we need to iterate through all user pages
        /// </summary>
        public IAsyncEnumerable<User> EnumerateUsersAsync();
        Task<Group> GetGroupsByIdAsync(Guid groupId);
        Task<User> GetUserByIdAsync(Guid userId);
        Task RemoveGroupMember(Guid groupId, Guid memberId);
    }
}
